/************************************************
 * This code is free to use, but this copyright
 * should be deleted, otherwise, they won't 
 * think you wrote it!
 * 
 * If you find this useful, please email me at
 * aprenot@aaronprenot.com
 * 
 * (c)2004 - Aaron Prenot
 * http://www.aaronprenot.com
 * **********************************************/
using System;

namespace Diff
{
	public enum DiffCommandType
	{
		Insert,
		Delete,
		Skip
	}
	/// <summary>
	/// 
	/// </summary>
	public struct DiffCommand
	{
		private DiffCommandType	_type;
		private object			_value;	// for insert
		private int				_length;	// for skip & delete
		
		internal DiffCommand(DiffCommandType type, IComparable val, int length)
		{
			this._length = length;
			this._type = type;
			this._value = val;
		}

		public object Value
		{
			get { return _value; }
		}

		public int Length
		{
			get { return _length; }
		}

		public DiffCommandType Type
		{
			get { return _type; }
		}

		public override string ToString(){
			switch (_type) {
			case DiffCommandType.Delete:
					return "-" + _length;
			case DiffCommandType.Insert:
					return "+" + _value;
			case DiffCommandType.Skip:
					return "*" + _length;
			}
			return "";
		}
	}
}
